blob: 0ec27bcd488da5cad6ead13d70accbdbc40d31ef [file] [log] [blame]
Guido van Rossum01b68fd1996-05-24 18:58:43 +00001#!/bin/sh
Guido van Rossum01b68fd1996-05-24 18:58:43 +00002#
3# install - install a program, script, or datafile
Guido van Rossum01b68fd1996-05-24 18:58:43 +00004#
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +00005# This originates from X11R5 (mit/util/scripts/install.sh), which was
6# later released in X11R6 (xc/config/util/install.sh) with the
7# following copyright and license.
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +00008#
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +00009# Copyright (C) 1994 X Consortium
10#
11# Permission is hereby granted, free of charge, to any person obtaining a copy
12# of this software and associated documentation files (the "Software"), to
13# deal in the Software without restriction, including without limitation the
14# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
15# sell copies of the Software, and to permit persons to whom the Software is
16# furnished to do so, subject to the following conditions:
17#
18# The above copyright notice and this permission notice shall be included in
19# all copies or substantial portions of the Software.
20#
21# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
22# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
23# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
24# X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
25# AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNEC-
26# TION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
27#
28# Except as contained in this notice, the name of the X Consortium shall not
29# be used in advertising or otherwise to promote the sale, use or other deal-
30# ings in this Software without prior written authorization from the X Consor-
31# tium.
32#
33#
34# FSF changes to this file are in the public domain.
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +000035#
36# Calling this script install-sh is preferred over install.sh, to prevent
37# `make' implicit rules from creating a file called install from it
38# when there is no Makefile.
Guido van Rossum01b68fd1996-05-24 18:58:43 +000039#
40# This script is compatible with the BSD install script, but was written
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +000041# from scratch. It can only install one file at a time, a restriction
42# shared with many OS's install programs.
Guido van Rossum01b68fd1996-05-24 18:58:43 +000043
44
45# set DOITPROG to echo to test this script
46
47# Don't use :- since 4.3BSD and earlier shells don't like it.
48doit="${DOITPROG-}"
49
50
51# put in absolute paths if you don't have them in your path; or use env. vars.
52
53mvprog="${MVPROG-mv}"
54cpprog="${CPPROG-cp}"
55chmodprog="${CHMODPROG-chmod}"
56chownprog="${CHOWNPROG-chown}"
57chgrpprog="${CHGRPPROG-chgrp}"
58stripprog="${STRIPPROG-strip}"
59rmprog="${RMPROG-rm}"
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +000060mkdirprog="${MKDIRPROG-mkdir}"
Guido van Rossum01b68fd1996-05-24 18:58:43 +000061
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +000062transformbasename=""
63transform_arg=""
Guido van Rossum01b68fd1996-05-24 18:58:43 +000064instcmd="$mvprog"
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +000065chmodcmd="$chmodprog 0755"
Guido van Rossum01b68fd1996-05-24 18:58:43 +000066chowncmd=""
67chgrpcmd=""
68stripcmd=""
69rmcmd="$rmprog -f"
70mvcmd="$mvprog"
71src=""
72dst=""
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +000073dir_arg=""
Guido van Rossum01b68fd1996-05-24 18:58:43 +000074
75while [ x"$1" != x ]; do
76 case $1 in
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +000077 -c) instcmd=$cpprog
Guido van Rossum01b68fd1996-05-24 18:58:43 +000078 shift
79 continue;;
80
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +000081 -d) dir_arg=true
82 shift
83 continue;;
84
Guido van Rossum01b68fd1996-05-24 18:58:43 +000085 -m) chmodcmd="$chmodprog $2"
86 shift
87 shift
88 continue;;
89
90 -o) chowncmd="$chownprog $2"
91 shift
92 shift
93 continue;;
94
95 -g) chgrpcmd="$chgrpprog $2"
96 shift
97 shift
98 continue;;
99
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000100 -s) stripcmd=$stripprog
Guido van Rossum01b68fd1996-05-24 18:58:43 +0000101 shift
102 continue;;
103
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000104 -t=*) transformarg=`echo $1 | sed 's/-t=//'`
105 shift
106 continue;;
107
108 -b=*) transformbasename=`echo $1 | sed 's/-b=//'`
109 shift
110 continue;;
111
Guido van Rossum01b68fd1996-05-24 18:58:43 +0000112 *) if [ x"$src" = x ]
113 then
114 src=$1
115 else
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000116 # this colon is to work around a 386BSD /bin/sh bug
117 :
Guido van Rossum01b68fd1996-05-24 18:58:43 +0000118 dst=$1
119 fi
120 shift
121 continue;;
122 esac
123done
124
125if [ x"$src" = x ]
126then
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000127 echo "$0: no input file specified" >&2
Guido van Rossum01b68fd1996-05-24 18:58:43 +0000128 exit 1
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000129else
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000130 :
Guido van Rossum01b68fd1996-05-24 18:58:43 +0000131fi
132
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000133if [ x"$dir_arg" != x ]; then
134 dst=$src
135 src=""
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000136
137 if [ -d "$dst" ]; then
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000138 instcmd=:
139 chmodcmd=""
140 else
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000141 instcmd=$mkdirprog
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000142 fi
143else
Guido van Rossum01b68fd1996-05-24 18:58:43 +0000144
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000145# Waiting for this to be detected by the "$instcmd $src $dsttmp" command
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000146# might cause directories to be created, which would be especially bad
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000147# if $src (and thus $dsttmp) contains '*'.
148
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000149 if [ -f "$src" ] || [ -d "$src" ]
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000150 then
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000151 :
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000152 else
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000153 echo "$0: $src does not exist" >&2
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000154 exit 1
155 fi
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000156
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000157 if [ x"$dst" = x ]
158 then
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000159 echo "$0: no destination specified" >&2
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000160 exit 1
161 else
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000162 :
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000163 fi
Guido van Rossum01b68fd1996-05-24 18:58:43 +0000164
165# If destination is a directory, append the input filename; if your system
166# does not like double slashes in filenames, you may need to add some logic
167
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000168 if [ -d "$dst" ]
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000169 then
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000170 dst=$dst/`basename "$src"`
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000171 else
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000172 :
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000173 fi
Guido van Rossum01b68fd1996-05-24 18:58:43 +0000174fi
175
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000176## this sed command emulates the dirname command
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000177dstdir=`echo "$dst" | sed -e 's,[^/]*$,,;s,/$,,;s,^$,.,'`
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000178
179# Make sure that the destination directory exists.
180# this part is taken from Noah Friedman's mkinstalldirs script
181
182# Skip lots of stat calls in the usual case.
183if [ ! -d "$dstdir" ]; then
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000184defaultIFS='
185 '
186IFS="${IFS-$defaultIFS}"
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000187
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000188oIFS=$IFS
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000189# Some sh's can't handle IFS=/ for some reason.
190IFS='%'
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000191set - `echo "$dstdir" | sed -e 's@/@%@g' -e 's@^%@/@'`
192IFS=$oIFS
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000193
194pathcomp=''
195
196while [ $# -ne 0 ] ; do
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000197 pathcomp=$pathcomp$1
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000198 shift
199
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000200 if [ ! -d "$pathcomp" ] ;
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000201 then
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000202 $mkdirprog "$pathcomp"
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000203 else
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000204 :
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000205 fi
206
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000207 pathcomp=$pathcomp/
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000208done
209fi
210
211if [ x"$dir_arg" != x ]
212then
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000213 $doit $instcmd "$dst" &&
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000214
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000215 if [ x"$chowncmd" != x ]; then $doit $chowncmd "$dst"; else : ; fi &&
216 if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd "$dst"; else : ; fi &&
217 if [ x"$stripcmd" != x ]; then $doit $stripcmd "$dst"; else : ; fi &&
218 if [ x"$chmodcmd" != x ]; then $doit $chmodcmd "$dst"; else : ; fi
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000219else
220
221# If we're going to rename the final executable, determine the name now.
222
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000223 if [ x"$transformarg" = x ]
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000224 then
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000225 dstfile=`basename "$dst"`
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000226 else
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000227 dstfile=`basename "$dst" $transformbasename |
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000228 sed $transformarg`$transformbasename
229 fi
230
231# don't allow the sed command to completely eliminate the filename
232
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000233 if [ x"$dstfile" = x ]
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000234 then
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000235 dstfile=`basename "$dst"`
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000236 else
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000237 :
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000238 fi
239
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000240# Make a couple of temp file names in the proper directory.
Guido van Rossum01b68fd1996-05-24 18:58:43 +0000241
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000242 dsttmp=$dstdir/#inst.$$#
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000243 rmtmp=$dstdir/#rm.$$#
244
245# Trap to clean up temp files at exit.
246
247 trap 'status=$?; rm -f "$dsttmp" "$rmtmp" && exit $status' 0
248 trap '(exit $?); exit' 1 2 13 15
Guido van Rossum01b68fd1996-05-24 18:58:43 +0000249
250# Move or copy the file name to the temp name
251
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000252 $doit $instcmd "$src" "$dsttmp" &&
Guido van Rossum01b68fd1996-05-24 18:58:43 +0000253
254# and set any options; do chmod last to preserve setuid bits
255
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000256# If any of these fail, we abort the whole thing. If we want to
257# ignore errors from any of these, just make sure not to ignore
258# errors from the above "$doit $instcmd $src $dsttmp" command.
259
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000260 if [ x"$chowncmd" != x ]; then $doit $chowncmd "$dsttmp"; else :;fi &&
261 if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd "$dsttmp"; else :;fi &&
262 if [ x"$stripcmd" != x ]; then $doit $stripcmd "$dsttmp"; else :;fi &&
263 if [ x"$chmodcmd" != x ]; then $doit $chmodcmd "$dsttmp"; else :;fi &&
264
265# Now remove or move aside any old file at destination location. We try this
266# two ways since rm can't unlink itself on some systems and the destination
267# file might be busy for other reasons. In this case, the final cleanup
268# might fail but the new file should still install successfully.
269
270{
271 if [ -f "$dstdir/$dstfile" ]
272 then
273 $doit $rmcmd -f "$dstdir/$dstfile" 2>/dev/null ||
274 $doit $mvcmd -f "$dstdir/$dstfile" "$rmtmp" 2>/dev/null ||
275 {
276 echo "$0: cannot unlink or rename $dstdir/$dstfile" >&2
277 (exit 1); exit
278 }
279 else
280 :
281 fi
282} &&
Guido van Rossum01b68fd1996-05-24 18:58:43 +0000283
284# Now rename the file to the real destination.
285
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000286 $doit $mvcmd "$dsttmp" "$dstdir/$dstfile"
Neil Schemenauerc62e0ef2001-02-10 20:04:53 +0000287
288fi &&
Guido van Rossum01b68fd1996-05-24 18:58:43 +0000289
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000290# The final little trick to "correctly" pass the exit status to the exit trap.
Guido van Rossum01b68fd1996-05-24 18:58:43 +0000291
Martin v. Löwisc1aa8dc2003-06-14 06:58:32 +0000292{
293 (exit 0); exit
294}